(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialiation Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)













BeginPackage["RewriteRuleDefs`",
	{"RewriteRules`"}];

Off[General::"spell"];



Def::usage=
  "Def[vars, {rule1, rule2, \[Ellipsis], rulen}] returns \"\[DownTee]\" if \
all rules `rulei` are well typed and \"\[UpTee]\" otherwise. Side effect:\n\
\[Bullet] append the results of encoding rulei (1\[LessEqual]i\[LessEqual]m) \
to RewriteRuleList[f], where f is the head function symbol of rulei. Here, m \
is the index of last well typed rule.";

MkCFLPRule::usage;





Begin["`Private`"];

$ContextPath=
	Join[
		{"Variables`","TermSyntax`","Types`",
				"Terms`","TypeChecker`","Debug`"},$ContextPath];











FormFunction[par_,localVar_,t_,{c___}]:=
	Function[par,
		Module[localVar,RewritesTo[t,c]]
	];









Clear[IsCFLPRule];
IsCFLPRule[_RightArrow|_RewriteRule]:=True;
IsCFLPRule[DoubleLeftArrow[_RightArrow,_]]:=True;
IsCFLPRule[_]:=False;











Clear[MkCFLPRule];
MkCFLPRule[RightArrow[lhs_,rhs_]]:=RewriteRule[lhs,rhs,{}];
MkCFLPRule[DoubleLeftArrow[RightArrow[lhs_,rhs_],cnd_]]:=
	RewriteRule[lhs,rhs,cnd];
MkCFLPRule[r_RewriteRule]:=r;







Def[{},True|False,_Integer] :="\[DownTee]";

Def[V_List,{rs___?IsCFLPRule},opts___]:=
	Block[
		{answer,
			saveType=DownValues[Type],
			oldV=Select[V/.{e_Pattern:>e\[LeftDoubleBracket]1\[RightDoubleBracket]},
          IsVar],
			newrs,
			tempV},
		newrs={rs}/.{TildeTilde\[Rule]eq};
		newrs=Map[MkCFLPRule,newrs];
		tempV=SetVariables[V];
		answer=Def[newrs,
				TypeCheck/.{opts}/.Options[TSolve`TSolve],1];
		ClearVariables[V];
		SetVariables[oldV];
		DownValues[Type]=saveType;
		answer];

Def[{RewriteRule[lhs_,rhs_,cnd_],rs___RewriteRule},tyChk_,n_Integer]:=
	(Block[{
				saveType=DownValues[Type],
				fsymb = If[Head[lhs] === Symbol, lhs, Head[lhs]],
				CFLPlhs=If[Head[lhs] === Symbol,lhs[],ListToCons[lhs]],
				CFLPrhs=ListToCons[rhs],
				CFLPcnd=WeakListToCons[cnd],
				parameter,cond,lhsV,rhsV,localV},
			If[Head[CFLPcnd]=!=List,CFLPcnd=List[CFLPcnd]];
			If[tyChk,
				If[Tc[RewriteRule[CFLPlhs,CFLPrhs,ToFormula[CFLPcnd]],KeepTypes->False]===
            "\[UpTee]",
					Print["Type check error at rule #",n];
					DownValues[Type]=saveType;
					Return["\[UpTee]"],
					DownValues[Type]=saveType
				]
			];
			If[IsConstructor[fsymb],
					Print["Constructor symbol ", fsymb, " redefined as a defined symbol."]; 
					IsConstructor[fsymb] =. ];
			IsDefinedSymbol[fsymb] = True;
			IsFunctionSymbol[fsymb] = True;
			{parameter, cond} =Uniform[CFLPlhs];
			lhsV = Var[CFLPlhs]; 
			rhsV = Var[{CFLPrhs, CFLPcnd}]; 
			localV = Union[rhsV, lhsV]; 
			If[$CFLPTraceLevel>0,
				Print["Adding rule #",n,": ",RewriteRule @@ {CFLPlhs,CFLPrhs,CFLPcnd}];
				PrintVarDecl[localV, Complement[rhsV,lhsV]]
			];
			AppendTo[RewriteRuleList[fsymb],
				FormFunction[parameter,localV,CFLPrhs,{cond,CFLPcnd}]]
		];
		Def[{rs},tyChk,n+1]);

Def[___]:=(Print["Error: wrong expressions specified as rewrite rules"];
    "\[UpTee]");





Clear[Flattening];
Flattening[s_]:=
	Module[{Global`w},
		AppendTo[Cond,ppeq[Global`w,s]];
		PatternVar=Join[PatternVar,Var[s]];
		Global`w];





Clear[PrintVarDecl];
PrintVarDecl[argVset_,argXV_]:=
	Module[
		{vset=Sort[argVset],xV=Sort[argXV],suffix1,suffix2,
		myInfix=Function[{x,y},If[Length[x]>1,Infix[x,y],First[x]]],
		suffix=Function[x,If[Length[x]>1,"s",""]]},
		Switch[vset,
			{},-1,
			{__},Print["Symbol",suffix[vset]," ",
				myInfix[vset,","]," declared as  variable", suffix[vset],"."]];
		Switch[xV,
			{},-1,
			{__},Print["Symbol",suffix[xV]," ",
				myInfix[xV,","]," declared as extra variable",suffix[xV],"."]
		]
	];		











Clear[Uniform];
Uniform[s_Symbol]:={{},{}};
Uniform[s_]:=
Block[{Cond = {}, PatternVar = {}}, {List @@ Flattening /@ s, Cond}];



End[];

On[General::"spell"];

EndPackage[];





















