(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialiation Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)













BeginPackage["TermSyntax`"];

Off[General::"spell"];



\[Bullet]sys::usage;DoubleVerticalBar::usage;Wedge::usage;

\[Bullet]ORbranches::usage=
  "\[Bullet]ORbranches is a data constructor used for handling the \
alternative search branches of the solution tree generated by the \
[||\[Dash]OR] inference rule of CFLP.";

eq::usage=
  "eq[ term1, term2 ] is the full form representation of the initial equation \
term1 \[TildeTilde] term2." ;

ppeq::usage=
  "ppeq[ term1, term2 ] is the full form representation of the parameter \
passing equation term1 \[CupCap] term2." ;

CSMark::usage=
  "CSMark[equation] is the full form representation of the marked equation \
\[LeftCeiling]equation\[RightCeiling]" ;

DelayMark::usage=
  "DelayMark[equation] is the full form representation of the marked equation \
\[LeftFloor]equation\[RightFloor]" ;

RewriteRule::usage=
  "RewriteRule[lhs, rhs, condition ] is the full form representation of the \
conditional rewrite rule `lhs \[RightArrow] rhs \[DoubleLeftArrow] \
condition`." ;

Cons::usage=
  "Cons[elem,list\[Dash]term] gives list\[Dash]term with elem prepended. It \
is the full form representation of \[LeftAngleBracket] elem, elem\[Dash]list \
\[RightAngleBracket]." ;

\[Bullet]::usage="\[Bullet] denotes the empty CFLP list.";ToCons::usage;

DoubleLeftArrow::usage;RightArrow::usage;

TildeTilde::usage=
  "an infix operator, x\[TildeTilde]y is by default interpreted as \
TildeTilde[x,y].";

\[Lambda]::usage=
  "\[Lambda] is the lambda term constructor. \[Lambda][x, body] is a lambda \
abstraction with a single formal argument x. \[Lambda][{x1, x2, \[Ellipsis] \
}, body ] is a lambda term with list {x1, x2, \[Ellipsis] } of formal \
arguments.";

\[Bullet]cnstr::usage=
  "\[Bullet]cnstr is reserved to the use of Calculus` and Scheduler`";





Begin["`Private`"];





MakeExpression[RowBox[{x_,"\[TildeTilde]",y_}],StandardForm]:=
	MakeExpression[RowBox[{"eq","[",x,",",y,"]"}],
		StandardForm];



eq/: MakeBoxes[eq[x_, y_], StandardForm] :=
	RowBox[ {MakeBoxes[x, StandardForm],
				"\[TildeTilde]", MakeBoxes[y, StandardForm]} 
	];





MakeExpression[RowBox[{x_,"\[CupCap]",y_}],StandardForm]:=
	MakeExpression[RowBox[{"ppeq","[",x,",",y,"]"}],
		StandardForm];



ppeq/: MakeBoxes[ppeq[x_, y_], StandardForm] :=
	RowBox[ {MakeBoxes[x, StandardForm],
				"\[CupCap]", MakeBoxes[y, StandardForm]} 
	];





MakeExpression[RowBox[{"\[LeftCeiling]",x_,"\[RightCeiling]"}],
    StandardForm]:=
	MakeExpression[RowBox[{"CSMark","[",x,"]"}],StandardForm];



CSMark/:MakeBoxes[CSMark[x_], StandardForm]:=
		RowBox[{"\[LeftCeiling]",MakeBoxes[x, StandardForm], "\[RightCeiling]"}];





MakeExpression[RowBox[{"\[LeftFloor]",x_,"\[RightFloor]"}],StandardForm]:=
	MakeExpression[RowBox[{"DelayMark","[",x,"]"}],StandardForm];



DelayMark/:MakeBoxes[DelayMark[x_], StandardForm]:=
		RowBox[{"\[LeftFloor]",MakeBoxes[x, StandardForm], "\[RightFloor]"}];





\[Bullet]ORbranches /: MakeBoxes[\[Bullet]ORbranches[x__], StandardForm] :=
	RowBox[ {MakeBoxes[DoubleVerticalBar[x], StandardForm]}];











RewriteRule /: MakeBoxes[RewriteRule[x_, y_,{}], StandardForm] :=
	RowBox[ {MakeBoxes[x, StandardForm],
				"\[RightArrow]", MakeBoxes[y, StandardForm]}
	];

RewriteRule /: MakeBoxes[RewriteRule[x_, y_,{z_}], StandardForm] :=
	 RowBox[ {MakeBoxes[x, StandardForm],
				"\[RightArrow]", MakeBoxes[y, StandardForm],"\[DoubleLeftArrow]",
			MakeBoxes[z, StandardForm]}
	];

RewriteRule /: MakeBoxes[RewriteRule[x_, y_,z_], StandardForm] :=
	 RowBox[ {MakeBoxes[x, StandardForm],
				"\[RightArrow]", MakeBoxes[y, StandardForm],"\[DoubleLeftArrow]",
			MakeBoxes[z, StandardForm]}
	];









Clear[ToCons];
ToCons[hd_,tl_]:=Cons[hd,tl];
ToCons[hds__,hd_,tl_]:=ToCons[hds,Cons[hd,tl]];
ToCons[hd_]:=hd;





MakeExpression[RowBox[{"[", 
      RowBox[{hd_, "|", tl_}], "]"}],StandardForm]:=
	MakeExpression[RowBox[{"Cons","[",hd,",",tl,"]"}],StandardForm];

MakeExpression[RowBox[{"[", 
      RowBox[{hds__, 
        RowBox[{hd_, "|", tl_}]}], "]"}],StandardForm]:=
	MakeExpression[RowBox[{"ToCons","[", 
      RowBox[{hds, 
        RowBox[{"Cons","[",hd,",",tl,"]"}]}], "]"}],StandardForm];













Clear[\[Lambda]];
\[Lambda]:=Function;



MakeExpression[RowBox[{"\[Lambda]", "[", 
      RowBox[{x_, ",", y_}], "]"}],StandardForm]:=
	MakeExpression[RowBox[{"Function", "[", 
      RowBox[{x, ",", y}], "]"}],
		StandardForm];



Attributes[Function]={HoldAll};
Function/:MakeBoxes[Function[x_,y_], StandardForm]:=
		RowBox[{"\[Lambda]","[",
      RowBox[{MakeBoxes[x, StandardForm],",",MakeBoxes[y, StandardForm]}],
      "]"}];
Attributes[Function]={HoldAll,Protected};





End[];

On[General::"spell"];

EndPackage[];











